#!/bin/bash
##########################################
# File Name: 21_check_service.sh
# Version: V1.1
# Author: zhangpeng
# Organization: linuxjk.cn
# Desc: 服务状态检查脚本
##########################################

# 1. 获取服务名称read -r禁用转义符
read -rp "Please input a service name: " service

# 2. 检查输入是否为空
if [ -z "$service" ]; then
    echo "Usage: sh $0 <service_name>"
    exit 1
fi

# 3. 检查服务是否存在--type确保只检查服务文件
# 直接通过 systemctl 查询（无需管道）
#if ! systemctl list-unit-files --type=service "$service.service" &>/dev/null
if ! systemctl list-unit-files --type=service | grep -qw "^$service.service"; then
    echo "Error: Service '$service' does not exist."
    exit 2
fi

# 4. 获取状态信息
run=$(systemctl is-active "$service")
auto=$(systemctl is-enabled "$service")

# 5. 判断逻辑优化
# 修正后的代码片段
#systemctl is-active "$service" &>/dev/null
#if [ $? -eq 0 ];then
#echo "$service is running"
#else
#echo "$service is running"
#fi
#和下面的格式不同效果一样：命令返回值为0则正确输出，不为0进入else，
#把命令放在if后的弊端：类似于expr那种成功的返回值为0或1 的命令不行
if systemctl is-active "$service" &>/dev/null
then
	echo "$service is running"
else
	echo "$service is not runing"
fi

if systemctl is-enabled "$service" &>/dev/null
then
	echo "$service is enabled"
else
	echo "$service is disenabled"
fi













#if [ "$run" = "active" ]; then
#    status1="running"
#else
#    status1="not running"
#fi

#if [ "$auto" = "enabled" ]; then
#    status2="enabled"
#else
#    status2="disabled"
#fi

#if [ "$run" = "active" ] && [ "$auto" = "enabled" ]; then
#    echo "$service is $status1, and $status2"
#elif [ "$run" = "active" ] && [ "$auto" != "enabled" ]; then
#    echo "$service is $status1"
#elif [ "$auto" = "disabled" ] && [ "$run" = "active" ]; then
#    echo "$service is $status2"
#else
#    echo "$service is not running and disabled"
#    exit 3
#fi
#exit 0
